
#include "bsp_iic.h"

/*
*********************************************************************************************************
*	  : i2c_Delay
*	˵: I2Cλӳ٣400KHz
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Delay(void)
{
	uint8_t i;

	/*
	 	ʱͨAX-Pro߼ǲԵõġ
		CPUƵ72MHzʱڲFlash, MDK̲Ż
		ѭΪ10ʱSCLƵ = 205KHz 
		ѭΪ7ʱSCLƵ = 347KHz SCLߵƽʱ1.5usSCL͵ƽʱ2.87us 
	 	ѭΪ5ʱSCLƵ = 421KHz SCLߵƽʱ1.25usSCL͵ƽʱ2.375us 
        
    IAṞЧʸߣΪ7
	*/
	for (i = 0; i < 10; i++);
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_Start(void)
{
	/* SCLߵƽʱSDAһرʾI2Cź */
	I2C_SDA_1();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_0();
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cֹͣź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_Stop(void)
{
	/* SCLߵƽʱSDAһرʾI2Cֹͣź */
	I2C_SDA_0();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_1();
}

/*
*********************************************************************************************************
*	  : i2c_SendByte
*	˵: CPUI2C豸8bit
*	    Σ_ucByte  ȴ͵ֽ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_Send_Byte(uint8_t _ucByte)
{
	uint8_t i;

	/* ȷֽڵĸλbit7 */
	for (i = 0; i < 8; i++)
	{		
		if (_ucByte & 0x80)
		{
			I2C_SDA_1();
		}
		else
		{
			I2C_SDA_0();
		}
		i2c_Delay();
		I2C_SCL_1();
		i2c_Delay();	
		I2C_SCL_0();
		if (i == 7)
		{
			 I2C_SDA_1(); // ͷ
		}
		_ucByte <<= 1;	/* һbit */
		i2c_Delay();
	}
}

/*
*********************************************************************************************************
*	  : i2c_ReadByte
*	˵: CPUI2C豸ȡ8bit
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
uint8_t IIC_Read_Byte(u8 ack)
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		I2C_SCL_1();
		i2c_Delay();
		if (I2C_SDA_READ())
		{
			value++;
		}
		I2C_SCL_0();
		i2c_Delay();
	}
	if (!ack)
        IIC_NAck();//??nACK
    else
        IIC_Ack(); //??ACK  
	return value;
}

/*
*********************************************************************************************************
*	  : i2c_WaitAck
*	˵: CPUһʱӣȡACKӦź
*	    Σ
*	  ֵ: 0ʾȷӦ1ʾӦ
*********************************************************************************************************
*/
uint8_t IIC_Wait_Ack(void)
{
	uint8_t re;

	I2C_SDA_1();	/* CPUͷSDA */
	i2c_Delay();
	I2C_SCL_1();	/* CPUSCL = 1, ʱ᷵ACKӦ */
	i2c_Delay();
	if (I2C_SDA_READ())	/* CPUȡSDA״̬ */
	{
		re = 1;
	}
	else
	{
		re = 0;
	}
	I2C_SCL_0();
	i2c_Delay();
	return re;
}

/*
*********************************************************************************************************
*	  : i2c_Ack
*	˵: CPUһACKź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_Ack(void)
{
	I2C_SDA_0();	/* CPUSDA = 0 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
	I2C_SDA_1();	/* CPUͷSDA */
}

/*
*********************************************************************************************************
*	  : i2c_NAck
*	˵: CPU1NACKź
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_NAck(void)
{
	I2C_SDA_1();	/* CPUSDA = 1 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();	
}

/*
*********************************************************************************************************
*	  : i2c_CfgGpio
*	˵: I2CߵGPIOģIOķʽʵ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void IIC_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_I2C_PORT, ENABLE);	/* GPIOʱ */

	GPIO_InitStructure.GPIO_Pin = I2C_SCL_PIN | I2C_SDA_PIN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;  	/* © */
	GPIO_Init(GPIO_PORT_I2C, &GPIO_InitStructure);

	/* һֹͣź, λI2Cϵ豸ģʽ */
	IIC_Stop();
}

/*
*********************************************************************************************************
*	  : i2c_CheckDevice
*	˵: I2C豸CPU豸ַȻȡ豸Ӧжϸ豸Ƿ
*	    Σ_Address豸I2Cߵַ
*	  ֵ: ֵ 0 ʾȷ 1ʾδ̽⵽
*********************************************************************************************************
*/
uint8_t i2c_CheckDevice(uint8_t _Address)
{
	uint8_t ucAck;

	IIC_Init();		/* GPIO */

	
	IIC_Start();		/* ź */

	/* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
	IIC_Send_Byte(_Address | I2C_WR);
	ucAck = IIC_Wait_Ack();	/* 豸ACKӦ */

	IIC_Stop();			/* ֹͣź */

	return ucAck;
}
